## freetype 2.0.9

=== Makefile ===
all: exes

####################################################################
#
# The `space' variable is used to avoid trailing spaces in defining the
# `T' variable later.
#
empty :=
space := $(empty) $(empty)


####################################################################
#
# TOP is the directory where the main FreeType source is found,
# as well as the 'config.mk' file
#
# TOP2 is the directory is the top of the demonstration
# programs directory
#

ifndef TOP
  TOP := ../freetype2
endif

ifndef TOP2
  TOP2 := .
endif


######################################################################
#
# MY_CONFIG_MK points to the current "config.mk" to use. It is
# defined by default as $(TOP)/config.mk
#
ifndef CONFIG_MK
  PROJECT   := freetype
  CONFIG_MK := $(TOP)/config.mk
endif

####################################################################
#
# Check that we have a working `config.mk' in the above directory.
# If not, issue a warning message, then stop there..
#
ifeq ($(wildcard $(CONFIG_MK)),)
  no_config_mk := 1
endif

ifdef no_config_mk
  exes:
	  @echo Please compile the library before the demo programs!
  clean distclean:
	  @echo "I need \`$(TOP)/config.mk' to do that!"
else

  ####################################################################
  #
  # Good, now include the `config.mk' in order to know how to build
  # object files from sources, as well as other things (compiler flags)
  #
  include $(CONFIG_MK)


  ####################################################################
  #
  # Define a few important variables now
  #
  ifeq ($(PLATFORM),unix)
    # without absolute paths libtool fails
    TOP  := $(shell cd $(TOP); pwd)
    TOP2 := $(shell cd $(TOP2); pwd)
    BIN_ := $(TOP2)$(SEP)bin$(SEP)
    OBJ_ := $(TOP2)$(SEP)obj$(SEP)
  else
    BIN_ := bin$(SEP)
    OBJ_ := obj$(SEP)
  endif

  TOP_  := $(TOP)$(SEP)
  TOP2_ := $(TOP2)$(SEP)
  SRC_  := $(TOP)$(SEP)src$(SEP)

  GRAPH_DIR := graph

  ifeq ($(TOP),..)
    SRC_DIR := src
  else
    SRC_DIR := $(TOP2_)src
  endif

  SRC_DIR_ := $(SRC_DIR)$(SEP)

  FT_INCLUDES := $(BUILD) $(TOP_)include $(SRC_) $(SRC_DIR)

  COMPILE = $(CC) $(CFLAGS) $(INCLUDES:%=$I%)

  FTLIB := $(LIB_DIR)$(SEP)$(LIBRARY).$A

  # "-lm" is required to compile on some Unix systems
  #
  ifeq ($(PLATFORM),unix)
    MATH := -lm
  endif

  ifeq ($(PLATFORM),unixdev)
    MATH := -lm
  endif

  # the default commands used to link the executables. These can
  # be re-defined for platform-specific stuff.
  #
  ifeq ($(PLATFORM),unix)
    CC   = $(CCraw)
    LINK = $(BUILD)/libtool --mode=link $(CC) $T$@ $< \
           $(LDFLAGS) $(FTLIB) $(EFENCE)
  else
    ifeq ($(PLATFORM),unixdev)
      LINK = $(CC) $T$@ $< $(FTLIB) $(EFENCE) -lm $(LDFLAGS)
    else
      LINK = $(CC) $T$@ $< $(FTLIB) $(EFENCE) $(LDFLAGS)
    endif
  endif
  
  COMMON_LINK = $(LINK) $(COMMON_OBJ)
  GRAPH_LINK  = $(COMMON_LINK) $(GRAPH_LIB)
  GRAPH_LINK2 = $(GRAPH_LINK) $(EXTRA_GRAPH_OBJS)

  .PHONY: exes clean distclean

  ###################################################################
  #
  # Include the rules needed to compile the graphics sub-system.
  # This will also select which graphics driver to compile to the
  # sub-system..
  #
  include $(GRAPH_DIR)/rules.mk

  ####################################################################
  #
  # Detect DOS-like platforms, currently DOS, Win 3.1, Win32 & OS/2
  #
  ifneq ($(findstring $(PLATFORM),os2 win16 win32 dos),)
    DOSLIKE := 1
  endif


  ###################################################################
  #
  # Clean-up rules.  Because the `del' command on DOS-like platforms
  # cannot take a long list of arguments, we simply erase the directory
  # contents.
  #
  ifdef DOSLIKE

    clean_demo:
	    -del obj\*.$(SO) 2> nul
	    -del $(subst /,\,$(TOP2))\src\*.bak 2> nul

    distclean_demo: clean_demo
	    -del obj\*.lib 2> nul
	    -del bin\*.exe 2> nul

  else

    clean_demo:
	    -$(DELETE) $(OBJ_)*.$(SO)
	    -$(DELETE) $(SRC_)*.bak graph$(SEP)*.bak
	    -$(DELETE) $(SRC_)*~ graph$(SEP)*~

    distclean_demo: clean_demo
	    -$(DELETE) $(EXES:%=$(BIN_)%$E)
	    -$(DELETE) $(GRAPH_LIB)
    ifeq ($(PLATFORM),unix)
	      -$(DELETE) $(BIN_).libs/*
	      -$(DELDIR) $(BIN_).libs
    endif

  endif

  clean: clean_demo
  distclean: distclean_demo

  ####################################################################
  #
  # Compute the executable suffix to use, and put it in `E'.
  # It is ".exe" on DOS-ish platforms, and nothing otherwise.
  #
  ifdef DOSLIKE
    E := .exe
  else
    E :=
  endif

  ###################################################################
  #
  # The list of demonstration programs to build.
  #
  EXES := ftlint ftmemchk ftdump testnames

  # Comment out the next line if you don't have a graphics subsystem.
  EXES += ftview ftmulti ftstring fttimer

  # Only uncomment the following lines if the truetype driver was
  # compiled with TT_CONFIG_OPTION_BYTECODE_INTERPRETER defined.
  #
  #  ifneq ($(findstring $(PLATFORM),os2 unix win32),)
  #    EXES += ttdebug
  #  endif

  exes: $(EXES:%=$(BIN_)%$E)


  INCLUDES := $(FT_INCLUDES)

  ####################################################################
  #
  # Rules for compiling object files for text-only demos
  #
  COMMON_OBJ := $(OBJ_)common.$(SO)
  $(COMMON_OBJ): $(SRC_DIR_)common.c
  ifdef DOSLIKE
	  $(COMPILE) $T$@ $< $DEXPAND_WILDCARDS 
  else
	  $(COMPILE) $T$@ $<
  endif


  $(OBJ_)%.$(SO): $(SRC_DIR_)%.c $(FTLIB)
	  $(COMPILE) $T$@ $<

  $(OBJ_)ftlint.$(SO): $(SRC_DIR_)ftlint.c
	  $(COMPILE) $T$@ $<

  $(OBJ_)compos.$(SO): $(SRC_DIR_)compos.c
	  $(COMPILE) $T$@ $<

  $(OBJ_)ftmemchk.$(SO): $(SRC_DIR_)ftmemchk.c
	  $(COMPILE) $T$@ $<

  $(OBJ_)fttry.$(SO): $(SRC_DIR_)fttry.c
	  $(COMPILE) $T$@ $<

  $(OBJ_)ftdump.$(SO): $(SRC_DIR_)ftdump.c
	  $(COMPILE) $T$@ $<

  $(OBJ_)testnames.$(SO): $(SRC_DIR_)testnames.c
	  $(COMPILE) $T$@ $<


  $(OBJ_)ftview.$(SO): $(SRC_DIR_)ftview.c $(GRAPH_LIB) $(SRC_DIR_)ftcommon.i
	  $(COMPILE) $(GRAPH_INCLUDES:%=$I%) $T$@ $<

  $(OBJ_)ftmulti.$(SO): $(SRC_DIR_)ftmulti.c $(GRAPH_LIB) $(SRC_DIR_)ftcommon.i
	  $(COMPILE) $(GRAPH_INCLUDES:%=$I%) $T$@ $<

  $(OBJ_)ftstring.$(SO): $(SRC_DIR_)ftstring.c $(GRAPH_LIB) $(SRC_DIR_)ftcommon.i
	  $(COMPILE) $(GRAPH_INCLUDES:%=$I%) $T$@ $<

  $(OBJ_)fttimer.$(SO): $(SRC_DIR_)fttimer.c $(GRAPH_LIB)
	  $(COMPILE) $(GRAPH_INCLUDES:%=$I%) $T$@ $<



# $(OBJ_)ftsbit.$(SO): $(SRC_DIR)/ftsbit.c $(GRAPH_LIB)
#	 $(COMPILE) $T$@ $<


  ####################################################################
  #
  # Special rule to compile the `t1dump' program as it includes
  # the Type1 source path
  #
  $(OBJ_)t1dump.$(SO): $(SRC_DIR)/t1dump.c
	  $(COMPILE) $T$@ $<


  ####################################################################
  #
  # Special rule to compile the `ttdebug' program as it includes
  # the TrueType source path and needs extra flags for correct keyboard
  # handling on Unix

  # POSIX TERMIOS: Do not define if you use OLD U*ix like 4.2BSD.
  #
  # detect a Unix system
  ifeq ($(PLATFORM),unix)
    EXTRAFLAGS = $DUNIX $DHAVE_POSIX_TERMIOS
  endif

  $(OBJ_)ttdebug.$(SO): $(SRC_DIR)/ttdebug.c
	    $(COMPILE) $I$(TOP)$(SEP)src$(SEP)truetype \
                       $(TT_INCLUDES:%=$I%) $T$@ $< $(EXTRAFLAGS)


  ####################################################################
  #
  # Rules used to link the executables. Note that they could be
  # over-ridden by system-specific things..
  #
  $(BIN_)ftlint$E: $(OBJ_)ftlint.$(SO) $(FTLIB) $(COMMON_OBJ)
	  $(COMMON_LINK)

  $(BIN_)ftmemchk$E: $(OBJ_)ftmemchk.$(SO) $(FTLIB) $(COMMON_OBJ)
	  $(COMMON_LINK)

  $(BIN_)compos$E: $(OBJ_)compos.$(SO) $(FTLIB) $(COMMON_OBJ)
	  $(COMMON_LINK)

  $(BIN_)ftdump$E: $(OBJ_)ftdump.$(SO) $(FTLIB)
	  $(COMMON_LINK)

  $(BIN_)fttry$E: $(OBJ_)fttry.$(SO) $(FTLIB)
	  $(LINK)

  $(BIN_)ftsbit$E: $(OBJ_)ftsbit.$(SO) $(FTLIB)
	  $(LINK)

  $(BIN_)t1dump$E: $(OBJ_)t1dump.$(SO) $(FTLIB)
	  $(LINK)

  $(BIN_)ttdebug$E: $(OBJ_)ttdebug.$(SO) $(FTLIB)
	  $(LINK)

  $(BIN_)testnames$E: $(OBJ_)testnames.$(SO) $(FTLIB)
	  $(LINK)


  $(BIN_)ftview$E: $(OBJ_)ftview.$(SO) $(FTLIB) $(GRAPH_LIB) $(COMMON_OBJ)
	  $(GRAPH_LINK)

  $(BIN_)ftmulti$E: $(OBJ_)ftmulti.$(SO) $(FTLIB) $(GRAPH_LIB) $(COMMON_OBJ)
	  $(GRAPH_LINK)

  $(BIN_)ftstring$E: $(OBJ_)ftstring.$(SO) $(FTLIB) $(GRAPH_LIB) $(COMMON_OBJ)
	  $(GRAPH_LINK) $(MATH)

  $(BIN_)fttimer$E: $(OBJ_)fttimer.$(SO) $(FTLIB) $(GRAPH_LIB) $(COMMON_OBJ)
	  $(GRAPH_LINK)


endif

# EOF

## freetype 1

=== debian/changelog ===
freetype (1-1) unstable; urgency=medium

  * update

 -- Hugh McMaster <hugh.mcmaster@outlook.com>  Tue, 10 May 2022 20:31:19 +0800

freetype (2.9.1.1-3+dde) unstable; urgency=medium

  * fix CVE-2022-27406 CVE-2022-27405 CVE-2022-27404

 -- wangyouwan <wangyouwan@uniontech.com>  Tue, 26 Apr 2022 15:21:12 +0800

freetype (2.9.1-3+deb10u2) unstable; urgency=low

  * ['Autobuild release-candidate: 7bd5c34879b601f19e8cd8be383ab9d7c61791b8']

 -- shuttle <shuttle@deepin.com>  Thu, 05 Nov 2020 12:57:49 +0000

=== debian/control ===
Source: freetype
Section: libs
Priority: optional
Maintainer: Hugh McMaster <hugh.mcmaster@outlook.com>
Uploaders: Anthony Fok <foka@debian.org>, Keith Packard <keithp@keithp.com>
Build-Depends: bzip2, debhelper (>= 11~), gettext, libx11-dev <!stage1>, x11proto-core-dev <!stage1>, libz-dev, pkg-config, libpng-dev, autoconf, libtool, libjs-jquery
Standards-Version: 4.2.1
Homepage: https://www.freetype.org
Vcs-Git: https://salsa.debian.org/debian/freetype.git
Vcs-Browser: https://salsa.debian.org/debian/freetype

Package: libfreetype6
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: FreeType 2 font engine, shared library files
 The FreeType project is a team of volunteers who develop free,
 portable and high-quality software solutions for digital typography.
 They specifically target embedded systems and focus on providing small,
 efficient and ubiquitous products.
 .
 The FreeType 2 library is their new software font engine.  It has been
 designed to provide the following important features:
  * A universal and simple API to manage font files
  * Support for several font formats through loadable modules
  * High-quality anti-aliasing
  * High portability & performance
 .
 Supported font formats include:
  * TrueType files (.ttf) and collections (.ttc)
  * Type 1 font files both in ASCII (.pfa) or binary (.pfb) format
  * Type 1 Multiple Master fonts.  The FreeType 2 API also provides
    routines to manage design instances easily
  * Type 1 CID-keyed fonts
  * OpenType/CFF (.otf) fonts
  * CFF/Type 2 fonts
  * Adobe CEF fonts (.cef), used to embed fonts in SVG documents with
    the Adobe SVG viewer plugin.
  * Windows FNT/FON bitmap fonts
 .
 This package contains the files needed to run programs that use the
 FreeType 2 library.

Package: libfreetype6-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libfreetype6 (= ${binary:Version}), libc6-dev | libc-dev, zlib1g-dev | libz-dev, libpng-dev, ${misc:Depends}
Suggests: freetype2-doc (= ${binary:Version})
Description: FreeType 2 font engine, development files
 The FreeType project is a team of volunteers who develop free,
 portable and high-quality software solutions for digital typography.
 They specifically target embedded systems and focus on providing small,
 efficient and ubiquitous products.
 .
 This package contains all of the supplementary files you need to develop your
 own programs using the FreeType 2 library.

Package: freetype2-demos
Section: utils
Architecture: any
Multi-Arch: foreign
Build-Profiles: <!stage1>
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: FreeType 2 demonstration programs
 The FreeType project is a team of volunteers who develop free,
 portable and high-quality software solutions for digital typography.
 They specifically target embedded systems and focus on providing small,
 efficient and ubiquitous products.
 .
 This package contains some demonstration programs and utilities
 that showcase the features of the FreeType 2 font engine.

Package: freetype2-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, ${misc:Depends}
Replaces: libfreetype6-dev (<< 2.9.1)
Breaks: libfreetype6-dev (<< 2.9.1)
Description: FreeType 2 font engine, development documentation
 The FreeType project is a team of volunteers who develop free,
 portable and high-quality software solutions for digital typography.
 They specifically target embedded systems and focus on providing small,
 efficient and ubiquitous products.
 .
 This package contains the FreeType 2 development documentation.

Package: libfreetype6-udeb
Section: debian-installer
Architecture: any
Package-Type: udeb
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: FreeType 2 font engine for the debian-installer
 The FreeType project is a team of volunteers who develop free,
 portable and high-quality software solutions for digital typography.
 They specifically target embedded systems and focus on providing small,
 efficient and ubiquitous products.
 .
 This is the udeb package for use with the debian-installer.

## freetype 2.1.7

=== Makefile ===
all: exes


####################################################################
#
# The `space' variable is used to avoid trailing spaces in defining
# the `T' variable later.
#
empty :=
space := $(empty) $(empty)


####################################################################
#
# TOP_DIR is the directory where the main FreeType source is found,
# as well as the `config.mk' file.
#
# TOP_DIR_2 is the directory is the top of the demonstration
# programs directory.
#
ifndef TOP_DIR
  TOP_DIR := ../freetype2
endif

ifndef TOP_DIR_2
  TOP_DIR_2 := .
endif


######################################################################
#
# MY_CONFIG_MK points to the current `config.mk' to use.  It is
# defined by default as $(TOP_DIR)/config.mk.
#
ifndef CONFIG_MK
  PROJECT   := freetype
  CONFIG_MK := $(TOP_DIR)/config.mk
endif


####################################################################
#
# Check that we have a working `config.mk' in the above directory.
# If not, issue a warning message, then stop there.
#
ifeq ($(wildcard $(CONFIG_MK)),)
  no_config_mk := 1
endif

ifdef no_config_mk

  exes:
	  @echo Please compile the library before the demo programs!
  clean distclean:
	  @echo "I need \`$(subst /,$(SEP),$(TOP_DIR)/config.mk)' to do that!"

else

  ####################################################################
  #
  # Good, now include `config.mk' in order to know how to build
  # object files from sources, as well as other things (compiler
  # flags).
  #
  include $(CONFIG_MK)


  ####################################################################
  #
  # Define a few important variables now.
  #
  ifeq ($(PLATFORM),unix)
    # without absolute paths libtool fails
    TOP_DIR   := $(shell cd $(TOP_DIR); pwd)
    TOP_DIR_2 := $(shell cd $(TOP_DIR_2); pwd)
    BIN_DIR   := $(TOP_DIR_2)/bin
    OBJ_DIR   := $(TOP_DIR_2)/obj
  else
    BIN_DIR := bin
    OBJ_DIR := obj
  endif

  GRAPH_DIR := graph

  ifeq ($(TOP_DIR),..)
    SRC_DIR := src
  else
    SRC_DIR := $(TOP_DIR_2)/src
  endif

  FT_INCLUDES := $(BUILD_DIR) $(TOP_DIR)/include $(SRC_DIR)

  COMPILE = $(CC) $(CFLAGS) $(INCLUDES:%=$I%)

  FTLIB := $(LIB_DIR)/$(LIBRARY).$A

  # `-lm' is required to compile on some Unix systems.
  #
  ifeq ($(PLATFORM),unix)
    MATH := -lm
  endif

  ifeq ($(PLATFORM),unixdev)
    MATH := -lm
  endif

  # The default commands used to link the executables.  These can
  # be redefined for platform-specific stuff.
  #
  ifeq ($(PLATFORM),unix)
    CC   = $(CCraw)
    LINK = $(subst /,$(SEP),$(BUILD_DIR)/libtool) --mode=link $(CC) \
           $T$(subst /,$(COMPILER_SEP),$@ $< $(LDFLAGS) $(FTLIB) $(EFENCE))
  else
    ifeq ($(PLATFORM),unixdev)
      LINK = $(CC) $T$(subst /,$(COMPILER_SEP),$@ $< $(FTLIB) \
                               $(EFENCE) -lm $(LDFLAGS))
    else
      LINK = $(CC) $T$(subst /,$(COMPILER_SEP),$@ $< $(FTLIB) \
                               $(EFENCE) $(LDFLAGS))
    endif
  endif
  
  COMMON_LINK = $(LINK) $(subst /,$(COMPILER_SEP),$(COMMON_OBJ))
  GRAPH_LINK  = $(COMMON_LINK) $(subst /,$(COMPILER_SEP),$(GRAPH_LIB))
  GRAPH_LINK2 = $(GRAPH_LINK) $(subst /,$(COMPILER_SEP),$(EXTRA_GRAPH_OBJS))

  .PHONY: exes clean distclean


  ###################################################################
  #
  # Include the rules needed to compile the graphics sub-system.
  # This will also select which graphics driver to compile to the
  # sub-system.
  #
  include $(GRAPH_DIR)/rules.mk


  ####################################################################
  #
  # Detect DOS-like platforms, currently DOS, Win 3.1, Win32 & OS/2.
  #
  ifneq ($(findstring $(PLATFORM),os2 win16 win32 dos),)
    DOSLIKE := 1
  endif


  ###################################################################
  #
  # Clean-up rules.  Because the `del' command on DOS-like platforms
  # cannot take a long list of arguments, we simply erase the directory
  # contents.
  #
  ifdef DOSLIKE

    clean_demo:
	    -del obj\*.$(SO) 2> nul
	    -del $(subst /,\,$(TOP_DIR_2)/src/*.bak) 2> nul

    distclean_demo: clean_demo
	    -del obj\*.lib 2> nul
	    -del bin\*.exe 2> nul

  else

    clean_demo:
	    -$(DELETE) $(subst /,$(SEP),$(OBJ_DIR)/*.$(SO))
	    -$(DELETE) $(subst /,$(SEP),$(SRC_DIR)/*.bak graph/*.bak)
	    -$(DELETE) $(subst /,$(SEP),$(SRC_DIR)/*~ graph/*~)

    distclean_demo: clean_demo
	    -$(DELETE) $(subst /,$(SEP),$(EXES:%=$(BIN_DIR)/%$E))
	    -$(DELETE) $(subst /,$(SEP),$(GRAPH_LIB))
    ifeq ($(PLATFORM),unix)
	      -$(DELETE) $(BIN_DIR)/.libs/*
	      -$(DELDIR) $(BIN_DIR)/.libs
    endif

  endif

  clean:     clean_demo
  distclean: distclean_demo


  ####################################################################
  #
  # Compute the executable suffix to use, and put it in `E'.
  # It is ".exe" on DOS-ish platforms, and nothing otherwise.
  #
  ifdef DOSLIKE
    E := .exe
  else
    E :=
  endif


  ###################################################################
  #
  # The list of demonstration programs to build.
  #
  EXES := ftlint ftmemchk ftdump testname fttimer ftbench ftchkwd

  # Comment out the next line if you don't have a graphics subsystem.
  EXES += ftview ftmulti ftstring

  # Only uncomment the following lines if the truetype driver was
  # compiled with TT_CONFIG_OPTION_BYTECODE_INTERPRETER defined.
  #
  #  ifneq ($(findstring $(PLATFORM),os2 unix win32),)
  #    EXES += ttdebug
  #  endif

  exes: $(EXES:%=$(BIN_DIR)/%$E)


  INCLUDES := $(subst /,$(COMPILER_SEP),$(FT_INCLUDES))


  ####################################################################
  #
  # Rules for compiling object files for text-only demos.
  #
  COMMON_OBJ := $(OBJ_DIR)/common.$(SO)
  $(COMMON_OBJ): $(SRC_DIR)/common.c
  ifdef DOSLIKE
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<) $DEXPAND_WILDCARDS 
  else
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<)
  endif


  $(OBJ_DIR)/%.$(SO): $(SRC_DIR)/%.c $(FTLIB)
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<)

  $(OBJ_DIR)/ftlint.$(SO): $(SRC_DIR)/ftlint.c
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<)

  $(OBJ_DIR)/ftbench.$(SO): $(SRC_DIR)/ftbench.c
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<) $(EXTRAFLAGS)

  $(OBJ_DIR)/ftchkwd.$(SO): $(SRC_DIR)/ftchkwd.c
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<) $(EXTRAFLAGS)

  $(OBJ_DIR)/compos.$(SO): $(SRC_DIR)/compos.c
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<)

  $(OBJ_DIR)/ftmemchk.$(SO): $(SRC_DIR)/ftmemchk.c
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<)

  $(OBJ_DIR)/fttry.$(SO): $(SRC_DIR)/fttry.c
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<)

  $(OBJ_DIR)/ftdump.$(SO): $(SRC_DIR)/ftdump.c
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<)

  $(OBJ_DIR)/testname.$(SO): $(SRC_DIR)/testname.c
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<)


  $(OBJ_DIR)/ftview.$(SO): $(SRC_DIR)/ftview.c \
                           $(GRAPH_LIB) $(SRC_DIR)/ftcommon.i
	  $(COMPILE) $(GRAPH_INCLUDES:%=$I%) \
                     $T$(subst /,$(COMPILER_SEP),$@ $<) \

  $(OBJ_DIR)/ftmulti.$(SO): $(SRC_DIR)/ftmulti.c \
                            $(GRAPH_LIB) $(SRC_DIR)/ftcommon.i
	  $(COMPILE) $(GRAPH_INCLUDES:%=$I%) \
                     $T$(subst /,$(COMPILER_SEP),$@ $<) \

  $(OBJ_DIR)/ftstring.$(SO): $(SRC_DIR)/ftstring.c \
                             $(GRAPH_LIB) $(SRC_DIR)/ftcommon.i
	  $(COMPILE) $(GRAPH_INCLUDES:%=$I%) \
                     $T$(subst /,$(COMPILER_SEP),$@ $<) \

  $(OBJ_DIR)/fttimer.$(SO): $(SRC_DIR)/fttimer.c $(GRAPH_LIB)
	  $(COMPILE) $(GRAPH_INCLUDES:%=$I%) \
                     $T$(subst /,$(COMPILER_SEP),$@ $<) \


# $(OBJ_DIR)/ftsbit.$(SO): $(SRC_DIR)/ftsbit.c $(GRAPH_LIB)
#	 $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<)


  ####################################################################
  #
  # Special rule to compile the `t1dump' program as it includes
  # the Type1 source path.
  #
  $(OBJ_DIR)/t1dump.$(SO): $(SRC_DIR)/t1dump.c
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<)


  ####################################################################
  #
  # Special rule to compile the `ttdebug' program as it includes
  # the TrueType source path and needs extra flags for correct keyboard
  # handling on Unix.

  # POSIX TERMIOS: Do not define if you use OLD U*ix like 4.2BSD.
  #
  # detect a Unix system
  #
  ifeq ($(PLATFORM),unix)
    EXTRAFLAGS = $DUNIX $DHAVE_POSIX_TERMIOS
  endif

  $(OBJ_DIR)/ttdebug.$(SO): $(SRC_DIR)/ttdebug.c
	  $(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<) \
                     $I$(subst /,$(COMPILER_SEP),$(TOP_DIR)/src/truetype) \
                     $(EXTRAFLAGS)


  ####################################################################
  #
  # Rules used to link the executables.  Note that they could be
  # overridden by system-specific things.
  #
  $(BIN_DIR)/ftlint$E: $(OBJ_DIR)/ftlint.$(SO) $(FTLIB) $(COMMON_OBJ)
	  $(COMMON_LINK)

  $(BIN_DIR)/ftbench$E: $(OBJ_DIR)/ftbench.$(SO) $(FTLIB) $(COMMON_OBJ)
	  $(COMMON_LINK)

  $(BIN_DIR)/ftchkwd$E: $(OBJ_DIR)/ftchkwd.$(SO) $(FTLIB) $(COMMON_OBJ)
	  $(COMMON_LINK)

  $(BIN_DIR)/ftmemchk$E: $(OBJ_DIR)/ftmemchk.$(SO) $(FTLIB) $(COMMON_OBJ)
	  $(COMMON_LINK)

  $(BIN_DIR)/compos$E: $(OBJ_DIR)/compos.$(SO) $(FTLIB) $(COMMON_OBJ)
	  $(COMMON_LINK)

  $(BIN_DIR)/ftdump$E: $(OBJ_DIR)/ftdump.$(SO) $(FTLIB)
	  $(COMMON_LINK)

  $(BIN_DIR)/fttry$E: $(OBJ_DIR)/fttry.$(SO) $(FTLIB)
	  $(LINK)

  $(BIN_DIR)/ftsbit$E: $(OBJ_DIR)/ftsbit.$(SO) $(FTLIB)
	  $(LINK)

  $(BIN_DIR)/t1dump$E: $(OBJ_DIR)/t1dump.$(SO) $(FTLIB)
	  $(LINK)

  $(BIN_DIR)/ttdebug$E: $(OBJ_DIR)/ttdebug.$(SO) $(FTLIB)
	  $(LINK)

  $(BIN_DIR)/testname$E: $(OBJ_DIR)/testname.$(SO) $(FTLIB)
	  $(LINK)


  $(BIN_DIR)/ftview$E: $(OBJ_DIR)/ftview.$(SO) $(FTLIB) \
                       $(GRAPH_LIB) $(COMMON_OBJ)
	  $(GRAPH_LINK)

  $(BIN_DIR)/ftmulti$E: $(OBJ_DIR)/ftmulti.$(SO) $(FTLIB) \
                        $(GRAPH_LIB) $(COMMON_OBJ)
	  $(GRAPH_LINK)

  $(BIN_DIR)/ftstring$E: $(OBJ_DIR)/ftstring.$(SO) $(FTLIB) \
                         $(GRAPH_LIB) $(COMMON_OBJ)
	  $(GRAPH_LINK) $(MATH)

  $(BIN_DIR)/fttimer$E: $(OBJ_DIR)/fttimer.$(SO) $(FTLIB) \
                        $(GRAPH_LIB) $(COMMON_OBJ)
	  $(GRAPH_LINK)


endif

# EOF

## freetype 2.3.7

=== mac/Makefile ===
##################################################################
#
# Makefile for MacOS X to build MacOS-specific API test program,
# Also targets to setup vanilla source for MPW are included.
# This should be executed in this directory, as
# "cd ft2demos ; make -C mac".
#
# most part is taken from ft2demos/Makefile, for UNIX platform.
#

all: exes

empty :=
space := $(empty) $(empty)

TOP_DIR       ?= ../../freetype2
OBJ_DIR       ?= $(TOP_DIR)/objs
TOP_DIR_2     ?= ..
OBJ_DIR_2     ?= $(TOP_DIR_2)/obj
TOP_DIR_2_MAC ?= $(TOP_DIR_2)/mac

ifndef CONFIG_MK
  PROJECT   := freetype
  CONFIG_MK := $(TOP_DIR)/config.mk
endif

ifeq ($(wildcard $(CONFIG_MK)),)
  no_config_mk := 1
endif

ifdef no_config_mk
  exes:
	@echo Please compile the library before the demo programs!
  clean distclean:
	@echo "I need \`$(subst /,$(SEP),$(TOP_DIR)/config.mk)' to do that!"
else
  include $(CONFIG_MK)
  have_makefile := $(strip $(wildcard Makefile))
  TOP_DIR   := $(shell cd $(TOP_DIR); pwd)
  TOP_DIR_2 := $(shell cd $(TOP_DIR_2); pwd)
  ifneq ($(have_makefile),)
    BIN_DIR_2 ?= $(TOP_DIR_2)/bin
    OBJ_DIR_2 ?= $(TOP_DIR_2)/obj
  else
    BIN_DIR_2 ?= ..
    OBJ_DIR_2 ?= ..
  endif

  GRAPH_DIR := $(TOP_DIR_2)/graph
  include $(GRAPH_DIR)/rules.mk

  ifeq ($(TOP_DIR),..)
    SRC_DIR := src
  else
    SRC_DIR := $(TOP_DIR_2)/src
  endif

  FT_INCLUDES := $(OBJ_BUILD) $(BUILD_DIR) $(TOP_DIR)/include $(SRC_DIR)
  INCLUDES := $(subst /,$(COMPILER_SEP),$(FT_INCLUDES))
  COMPILE = $(CC) $(CFLAGS) $(INCLUDES:%=$I%)
  FTLIB := $(LIB_DIR)/$(LIBRARY).$A
  ifeq ($(PLATFORM),unix)
    MATH := -lm
  endif
  ifeq ($(PLATFORM),unixdev)
    MATH := -lm
  endif
  LINK_ITEMS = $T$(subst /,$(COMPILER_SEP),$@ $<)

  CC        = $(CCraw)
  LINK_CMD  = $(subst /,$(SEP),$(OBJ_BUILD)/libtool) \
		--mode=link $(CC) \
		$(subst /,$(COMPILER_SEP),$(LDFLAGS))
  ifeq ($(findstring CoreServices,$(LDFLAGS)),)
    LINK_LIBS = $(subst /,$(COMPILER_SEP),$(FTLIB) $(EFENCE)) $(MATH) \
		-Xlinker -framework -Xlinker CoreServices \
		-Xlinker -framework -Xlinker ApplicationServices
  else
  LINK_LIBS = $(subst /,$(COMPILER_SEP),$(FTLIB) $(EFENCE)) $(MATH)
  endif
  LINK_COMMON = $(LINK_CMD) \
		$(LINK_ITEMS) $(subst /,$(COMPILER_SEP),$(COMMON_OBJ)) \
		$(LINK_LIBS)

  .PHONY: exes clean distclean

  E :=
  EXES := ftoldmac
  exes: $(EXES:%=$(BIN_DIR_2)/%$E)

  $(BIN_DIR_2)/ftoldmac$E: $(OBJ_DIR_2)/ftoldmac.$(SO) $(FTLIB) $(COMMON_OBJ)
	$(LINK_COMMON)

  $(OBJ_DIR_2)/ftoldmac.$(SO): $(TOP_DIR_2_MAC)/ftoldmac.c
	$(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<) $DFT2_BUILD_LIBRARY

  COMMON_OBJ := $(OBJ_DIR_2)/common.$(SO)
  $(COMMON_OBJ): $(SRC_DIR)/common.c
	$(COMPILE) $T$(subst /,$(COMPILER_SEP),$@ $<) $DFT2_BUILD_LIBRARY

  ################################################################
  # Targets to setup MPW
  #

  clean:
	rm -f \
		$(TOP_DIR_2)/ftoldmac.*.make \
		$(OBJ_DIR_2)/*.NJ \
		$(OBJ_DIR_2)/*.makeout \
		$(OBJ_DIR_2)/*.o $(OBJ_DIR_2)/*.exe

  makefiles:
	python $(TOP_DIR_2_MAC)/ascii2mpw.py \
		> $(TOP_DIR_2)/ftoldmac.m68k_far.make \
		< $(TOP_DIR_2_MAC)/ftoldmac.m68k_far.make.txt
	python $(TOP_DIR_2_MAC)/ascii2mpw.py \
		> $(TOP_DIR_2)/ftoldmac.ppc_classic.make \
		< $(TOP_DIR_2_MAC)/ftoldmac.ppc_classic.make.txt
	find $(TOP_DIR_2) -name '*.make' | \
	xargs /Developer/Tools/SetFile -a l -c "MPS " -t TEXT

  resource:
	find $(SRC_DIR) $(TOP_DIR_2_MAC) -name '*.[ch]' | \
	xargs /Developer/Tools/SetFile -a l -c "MPS " -t TEXT
endif

## freetype 2.3.9-1osso2%2b0m5

=== debian/changelog ===
freetype (2.3.9-1osso2+0m5) unstable; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- Kojo Aapo <aapo.kojo@nokia.com>  Fri, 05 Jun 2009 08:10:30 +0300

freetype (2.3.9-1osso2) unstable; urgency=low

  * Added: armel-asm-declaration.patch to fix a build failure on armel

 -- Richard Sun <richard.sun@nokia.com>  Thu,  4 Jun 2009 11:17:35 +0300

freetype (2.3.9-1osso1) unstable; urgency=low

  * Updated: Sync with upstream stable version
  * Added: security-CVE-2009-0946.patch from Ubuntu jaunty-security
  * Fixes: NB#111884 Multiple integer overflows in FreeType 2.3.9
  * Fixes: NB#86647 Freetype arbitrary code execution vulnerabilities

 -- Richard Sun <richard.sun@nokia.com>  Wed,  3 Jun 2009 18:17:13 +0300

freetype (2.3.5-1osso1) unstable; urgency=low

  * Updated: Upstream update from 2.2.1 to 2.3.5
  * Fixes: NB#57670
  * Removed: patch for CVE-2006-3467, which is already merged to
    upstream. 

 -- Richard Sun <richard.sun@nokia.com>  Thu, 13 Dec 2007 15:55:37 +0200

freetype (2.2.1-1osso3) unstable; urgency=low

  * Fixes: NB#46810 

 -- Richard Sun <richard.sun@nokia.com>  Mon, 20 Nov 2006 12:49:15 +0200

freetype (2.2.1-1osso2) unstable; urgency=low

  * Applied Debian patch for CVE-2006-3467 - when this one gets merged to
    upstream freetype we can remove it.
  * Editing the debian/copyright file: FTL license
  * Fixes: NB#40636

 -- Jakub Pavelek <jakub.pavelek@nokia.com>  Wed, 27 Sep 2006 17:15:59 +0300

freetype (2.2.1-1osso1) unstable; urgency=low

  * Upstream update from 2.1.10 to 2.2.1
  * Bugfixes, fixes NB#26659, NB#33547, NB#36268, NB#36269
  * Updated packaging

 -- Jakub Pavelek <jakub.pavelek@nokia.com>  Mon, 31 Jul 2006 15:54:22 +0300

freetype (2.1.10-1osso2) unstable; urgency=low

  * Fixes for SDK

 -- Jakub Pavelek <jakub.pavelek@nokia.com>  Fri,  7 Oct 2005 10:53:09 +0300

=== debian/control ===
Source: freetype
Section: devel
Priority: optional
Build-Depends: zlib1g-dev, bzip2
Maintainer:  Richard Sun <richard.sun@nokia.com>
Standards-Version: 3.5.9

Package: libfreetype6
Section: libs
Architecture: any
Depends: zlib1g
Description: FreeType 2 font engine, shared library files
 The FreeType project is a team of volunteers who develop free,
 portable and high-quality software solutions for digital typography.
 They specifically target embedded systems and focus on bringing small,
 efficient and ubiquitous products.

Package: libfreetype6-dev
Section: libs
Architecture: any
Depends: libfreetype6 (= ${Source-Version}), zlib1g-dev
Description: Development package for Freetype2.

Package: libfreetype6-dbg
Section: libs
Architecture: any
Depends: libfreetype6 (= ${Source-Version}), zlib1g
Description: Debugging symbols for Freetype2

=== debian/rules ===
#!/usr/bin/make -f


export DH_COMPAT=4

SHELL = /bin/bash

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

# Use soft-float and thumb mode if it enabled.
ifneq (,$(findstring thumb,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -mthumb
endif

export CFLAGS

configure: configure-stamp
configure-stamp:
	dh_testdir
	tar -xjf freetype-2.3.9.tar.bz2
	patch -p0 < security-CVE-2009-0946.patch
	patch -p0 < armel-asm-declaration.patch
	cd freetype-2.3.9 && ./configure --prefix=/usr --sysconfdir=/etc
	touch configure-stamp


build: configure-stamp build-stamp
build-stamp:
	dh_testdir
	$(MAKE) -C freetype-2.3.9
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	rm -rf freetype-2.3.9
	rm -fr objs/.libs
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	$(MAKE) -C freetype-2.3.9 install DESTDIR=$(CURDIR)/debian/tmp
	

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_makeshlibs -V
	dh_installchangelogs
	dh_install --sourcedir=debian/tmp -v
	dh_strip --dbg-package=libfreetype6
	dh_link
	dh_fixperms
	dh_makeshlibs -V
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## freetype 2.4.9-1.1+deb7u3

=== debian/changelog ===
freetype (2.4.9-1.1+deb7u3) wheezy-security; urgency=high

  * Non-maintainer upload by LTS team.
  * CVE-2014-9674: integer overflow and heap-based buffer overflow
    in Mac_Read_POST_Resource.  The added patch also includes the fixes for
    CVE-2014-9673 since they overlap. Closes: #777656

 -- Guido Günther <agx@sigxcpu.org>  Sun, 24 Jan 2016 19:41:13 +0100

freetype (2.4.9-1.1+deb7u2) wheezy-security; urgency=high

  * Non-maintainer upload.
  * CVE-2014-9745: Fix Savannah bug #41590. Protect against invalid number in
    t1load.c parse_encoding().
  * CVE-2014-9746, CVE-2014-9747: Fix Savannah bug #41309. Correct use of
    uninitialized data in t1load.c, cidload.c, t42parse.c and psobjs.c.

 -- Santiago Ruano Rincón <santiagorr@riseup.net>  Thu, 01 Oct 2015 08:43:16 +0200

freetype (2.4.9-1.1+deb7u1) wheezy-security; urgency=high

  * CVE-2014-9656 CVE-2014-9657 CVE-2014-9658 CVE-2014-9660 CVE-2014-9661
    CVE-2014-9663 CVE-2014-9664 CVE-2014-9666 CVE-2014-9667 CVE-2014-9669 
    CVE-2014-9670 CVE-2014-9671 CVE-2014-9672 CVE-2014-9673 CVE-2014-9675

 -- Moritz Mühlenhoff <jmm@debian.org>  Fri, 06 Mar 2015 19:31:14 +0100

freetype (2.4.9-1.1) unstable; urgency=high

  * Non-maintainer upload.
    Upload ACKed by Steve Langasek <vorlon@debian.org> on #debian-devel.
  * Add savannah-bug-37905.patch patch
    [SECURITY] CVE-2012-5668: NULL Pointer Dereference in bdf_free_font.
    (Closes: #696691)
  * Add savannah-bug-37906.patch patch
    [SECURITY] CVE-2012-5669: Out-of-bounds read in _bdf_parse_glyphs.
    (Closes: #696691)
  * Add savannah-bug-37907.patch patch
    [SECURITY] CVE-2012-5670: Out-of-bounds write in _bdf_parse_glyphs.
    (Closes: #696691)

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 28 Dec 2012 21:32:28 +0100

freetype (2.4.9-1) unstable; urgency=low

  * New upstream release
    - upstream fix for multiple vulnerabilities: CVE-2012-1126,
      CVE-2012-1133, CVE-2012-1134, CVE-2012-1136, CVE-2012-1142,
      CVE-2012-1144. and others.  Closes: #662864.
    - update symbols file for a new symbol, ft_raccess_guess_table
  * debian/patches-freetype/savannah-bug-35847.patch,
    debian/patches-freetype/savannah-bug-35833.patch: pull two bugfixes from
    upstream git on top of 2.4.9, to address regressions affecting
    ghostscript.  Thanks to Till Kamppeter for pointing this out.
  * push CPPFLAGS into CFLAGS for ft2demos, so our demos will be secure.
    Closes: #663613.
  * don't let a quiltrc override our QUILT_PATCHES settings in debian/rules.
    Closes: #617217.
  * Migrate debian/copyright to copyright-format 1.0, and fix up the upstream
    URL.  Closes: #642059.

 -- Steve Langasek <vorlon@debian.org>  Sat, 24 Mar 2012 23:35:16 +0000

freetype (2.4.8-1) unstable; urgency=high

  * New upstream release
    - upstream fix for CVE-2011-3439.  Closes: #649122.
    - adjust libfreetype6.symbols for a newly-exported function.

 -- Steve Langasek <vorlon@debian.org>  Thu, 17 Nov 2011 22:28:14 +0000

freetype (2.4.7-2) unstable; urgency=low

  * Use dpkg-buildflags through debhelper.
  * Don't set -Werror in CFLAGS on alpha or m68k, to work around a compiler
    bug.  Closes: #646334.

 -- Steve Langasek <vorlon@debian.org>  Mon, 24 Oct 2011 22:02:32 +0000

freetype (2.4.7-1) unstable; urgency=low

  * New upstream release
    - upstream fix for CVE-2011-3256.  Closes: #646120.
    - drop debian/patches-freetype/0001-Fix-Savannah-bug-33992.patch,
      included upstream.
  * Pass --without-bzip2 to configure, to avoid unwanted dependency on
    libbz2.  Closes: #639638.
  * Standards-Version 3.9.2.

 -- Steve Langasek <vorlon@debian.org>  Sat, 22 Oct 2011 20:18:59 +0000

freetype (2.4.6-2) unstable; urgency=low

  * debian/patches-freetype/0001-Fix-Savannah-bug-33992.patch: [PATCH]
    Fix Savannah bug #33992.  Thanks to David Bevan
    <david.bevan@pb.com>.  Closes: #638348.

 -- Steve Langasek <vorlon@debian.org>  Sat, 20 Aug 2011 06:30:18 +0000

freetype (2.4.6-1) unstable; urgency=low

  * New upstream release
    - fixes CVE-2011-0226, a vulnerability in parsing of Type 1 fonts.
      Closes: #635871.
    - upstream now builds cleanly with -Werror and the new gcc-4.6 upstream
      warnings.  Closes: #625328.

 -- Steve Langasek <vorlon@debian.org>  Thu, 04 Aug 2011 05:49:09 +0000

freetype (2.4.4-2) unstable; urgency=low

  * Build for multiarch, using debhelper compat 9.
  * Add Pre-Depends: ${misc:Pre-Depends} to pick up multiarch-support
    dependency.

 -- Steve Langasek <vorlon@debian.org>  Wed, 22 Jun 2011 14:38:12 -0700

freetype (2.4.4-1) unstable; urgency=low

  * Acknowledge security NMU - thanks, Moritz!
  * New upstream release, closes: #606286, #600321
    - fixes PDF rendering issues.  Closes: #612484, LP: #709229.
    - fixes a rendering issue with 'S' glyphs in certain fonts.
      LP: #654010.
    - drop patches for CVE-2010-3855 and CVE-2010-3814, applied upstream.
    - drop patch ft2demos-2.1.7-ftbench.patch; doesn't apply cleanly, the
      code has changed significantly, patch never forwarded upstream.  If
      this is still an issue, someone will provide a fixed patch.
    - drop patch ft2demos-grkey.patch, fixed upstream.
  * debian/patches-freetype/enable-gxvalid-otvalid.patch: enable the
    otvalid and gxvalid table validation modules.  Thanks to Paul Wise
    <pabs@debian.org>.  Closes: #520879, LP: #239626.
  * debian/libfreetype6.symbols: update the symbols file for the same.
  * debian/rules et al.: convert to dh 7
  * drop INSTALL.* from the libfreetype6-dev docs.  Closes: #550971.
  * move homepage out of debian/copyright and into debian/control.
  * fix GPL link to point to GPL-2 explicitly.
  * clean up long-obsolete conflicts/replaces.
  * drop debian/README.quilt, redundant with debian/README.source.
  * drop debian/README.Debian, which talks about the long-finished transition
    from freetype1.
  * strip dependency_libs out of /usr/lib/libfreetype.la.
  * bump standards-version to 3.9.1.



=== debian/control ===
Source: freetype
Section: libs
Priority: optional
Maintainer: Steve Langasek <vorlon@debian.org>
Uploaders: Anthony Fok <foka@debian.org>, Keith Packard <keithp@keithp.com>
Build-Depends: bzip2, debhelper (>= 8.9.4), docbook-to-man, gettext (>= 0.10.36-2), libx11-dev, x11proto-core-dev, libz-dev, quilt
Standards-Version: 3.9.2
Homepage: http://www.freetype.org

Package: libfreetype6
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: FreeType 2 font engine, shared library files
 The FreeType project is a team of volunteers who develop free,
 portable and high-quality software solutions for digital typography. 
 They specifically target embedded systems and focus on bringing small,
 efficient and ubiquitous products.
 .
 The FreeType 2 library is their new software font engine.  It has been
 designed to provide the following important features:
  * A universal and simple API to manage font files
  * Support for several font formats through loadable modules
  * High-quality anti-aliasing
  * High portability & performance
 .
 Supported font formats include:
  * TrueType files (.ttf) and collections (.ttc)
  * Type 1 font files both in ASCII (.pfa) or binary (.pfb) format
  * Type 1 Multiple Master fonts.  The FreeType 2 API also provides
    routines to manage design instances easily
  * Type 1 CID-keyed fonts
  * OpenType/CFF (.otf) fonts
  * CFF/Type 2 fonts
  * Adobe CEF fonts (.cef), used to embed fonts in SVG documents with
    the Adobe SVG viewer plugin.
  * Windows FNT/FON bitmap fonts
 .
 This package contains the files needed to run programs that use the
 FreeType 2 library.
 .
  Home Page: http://www.freetype.org/
  Authors: David Turner   <david.turner@freetype.org>
           Robert Wilhelm <robert.wilhelm@freetype.org>
           Werner Lemberg <werner.lemberg@freetype.org>

Package: libfreetype6-dev
Architecture: any
Section: libdevel
Depends: libfreetype6 (= ${binary:Version}), libc6-dev | libc-dev, zlib1g-dev | libz-dev, ${misc:Depends}
Description: FreeType 2 font engine, development files
 The FreeType project is a team of volunteers who develop free,
 portable and high-quality software solutions for digital typography. 
 They specifically target embedded systems and focus on bringing small,
 efficient and ubiquitous products.
 .
 This package contains all supplementary files (static library, headers
 and documentation) you need to develop your own programs using the
 FreeType 2 library.

Package: freetype2-demos
Architecture: any
Section: utils
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: freetype-tools
Description: FreeType 2 demonstration programs
 This package contains some demonstration programs and utilities
 which showcase the features of the FreeType 2 font engine.

Package: libfreetype6-udeb
XC-Package-Type: udeb
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: debian-installer
Description: FreeType 2 font engine for the debian-installer
 The FreeType project is a team of volunteers who develop free,
 portable and high-quality software solutions for digital typography.
 They specifically target embedded systems and focus on bringing small,
 efficient and ubiquitous products.
 .
 This is the udeb package for use with the debian-installer.

=== debian/rules ===
#!/usr/bin/make -f
#
# This is free software; see the GNU General Public Licence
# version 2 or later for copying conditions.  There is NO warranty.

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Workaround for spurious error when building with gcc-4.4
ifeq (,$(filter m68k alpha,$(DEB_HOST_ARCH)))
export DEB_CFLAGS_MAINT_APPEND := -Werror
endif
export DEB_CFLAGS_MAINT_APPEND += $(shell dpkg-buildflags --get CPPFLAGS)

# always abort if there are any problems with the symbols file
DPKG_GENSYMBOLS_CHECK_LEVEL = 4
export DPKG_GENSYMBOLS_CHECK_LEVEL

VERSION = $(shell dpkg-parsechangelog | sed -n -e's/^Version: //p')
ver := $(shell dpkg-parsechangelog | sed -n -e's/^Version: \(.*\)-[^-]\+/\1/p')

freetype_ver := $(ver)
ftdocs_ver   := $(ver)
ft2demos_ver := $(ver)
dependency = $(libpkg) (>= 2.4.0)

freetype_u := freetype-$(freetype_ver)
ftdocs_u   := freetype-doc-$(ftdocs_ver)
ftdocs_d   := $(freetype_u)
ft2demos_u := ft2demos-$(ft2demos_ver)

libpkg := libfreetype6
devpkg := $(libpkg)-dev
docpkg := $(libpkg)-doc
demospkg := freetype2-demos
udebpkg := libfreetype6-udeb
docdir := usr/share/doc
freetype_config_man := $(CURDIR)/debian/freetype-config.man
freetype_config_sgml := $(CURDIR)/debian/freetype-config.man.sgml

libdoc = FTL.TXT CHANGES TODO ft2faq.html

%:
	dh $@

unpack:: unpack-stamp
unpack-stamp::
	# Unpack upstream tarballs
	@for i in $(freetype_u) $(ftdocs_u) $(ft2demos_u); do \
	    if [ -f $$i.tar.bz2 ]; then \
		echo "Unpacking $$i.tar.bz2 ..."; \
		tar -x --bzip2 -f $$i.tar.bz2; \
	    elif [ -f $$i.tar.gz ]; then \
		echo "Unpacking $$i.tar.gz ..."; \
		tar -x --gzip -f $$i.tar.gz; \
	    else \
		echo "Error!  $$i.tar.{bz2,gz} not found!"; \
		exit 1; \
	    fi \
	done
	ln -s $(ftdocs_d)/docs docs
	touch unpack-stamp

patch: unpack patch-stamp
patch-stamp:
	cd $(freetype_u) \
	    && QUILT_PATCHES=../debian/patches-freetype quilt --quiltrc /dev/null push -a
	cd $(ft2demos_u) \
	    && QUILT_PATCHES=../debian/patches-ft2demos quilt --quiltrc /dev/null push -a
	touch patch-stamp

override_dh_auto_configure: patch
	dh_auto_configure -D $(freetype_u) -- --without-bzip2

override_dh_auto_build:
	dh_auto_build -D $(freetype_u)
	dh_auto_build -D $(ft2demos_u) -- TOP_DIR=../$(freetype_u) \
		OBJ_DIR=../$(freetype_u)/objs
	docbook-to-man $(freetype_config_sgml) > $(freetype_config_man)

override_dh_auto_clean:
	rm -f $(freetype_config_man)
	rm -f unpack-stamp patch-stamp
	rm -rf $(freetype_u) $(ft2demos_u) docs

override_dh_auto_install:
	dh_auto_install -D $(freetype_u) --destdir=$(CURDIR)/debian/tmp
	$(freetype_u)/builds/unix/libtool --mode=install \
	    cp -av `find $(ft2demos_u)/bin -type f -perm -u=x -maxdepth 1` \
		$(CURDIR)/debian/$(demospkg)/usr/bin/
	sed -i -e'/dependency_libs/s/'.*'//' debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libfreetype.la

override_dh_install:
	dh_install --fail-missing

override_dh_installdocs:
ifneq (,$(findstring $(libpkg), $(shell dh_listpackages)))
	dh_installdocs -p$(libpkg) $(addprefix $(freetype_u)/docs/,$(libdoc))
	mkdir debian/$(libpkg)/$(docdir)/$(libpkg)/pcf
	cp -a $(freetype_u)/src/pcf/README debian/$(libpkg)/$(docdir)/$(libpkg)/pcf/
endif
ifneq (,$(findstring $(devpkg), $(shell dh_listpackages)))
	dh_installdocs --link-doc=$(libpkg) -p$(devpkg) \
		-Xreference/README -Xreference/.gitignore \
		-XLICENSE.TXT -XGPL.TXT -XBUILD -XINSTALL \
		$(addprefix -X,$(libdoc)) \
		$(ftdocs_d)/docs/*
endif
	dh_installdocs -N$(devpkg) -N$(libpkg) --link-doc=$(libpkg)

override_dh_installchangelogs:
ifneq (,$(findstring $(libpkg), $(shell dh_listpackages)))
	dh_installchangelogs -p$(libpkg) $(freetype_u)/ChangeLog
endif

override_dh_makeshlibs:
	dh_makeshlibs -V '$(dependency)' --add-udeb '$(udebpkg)'

# This variable is used only by get-orig-source, which will normally only
# be run by maintainers.
URL	= http://savannah.nongnu.org/download/freetype/

# Download the various upstream source tarballs and pack them into a
# single orig.tar.gz.  Assumes wget and gpg are available.
get-orig-source:
	@if [ ! -d "debian" ] ; then \
	    echo 'Run this from the top directory of the Debian source' >&2; \
	    exit 1; \
	fi
	mkdir freetype-$(ver)
	set -e; \
	cd freetype-$(ver); \
	for i in freetype freetype-doc ft2demos; do \
		wget $(URL)/$$i-$(ver).tar.bz2; \
		wget $(URL)/$$i-$(ver).tar.bz2.sig; \
		gpg --verify $$i-$(ver).tar.bz2.sig $$i-$(ver).tar.bz2 \
		&& rm $$i-$(ver).tar.bz2.sig; \
	done
	tar cf freetype_$(ver).orig.tar freetype-$(ver)
	rm -rf freetype-$(ver)
	gzip -9 freetype_$(ver).orig.tar

.PHONY: unpack patch get-orig-source

## freetype 2.4.9-1.1+deb7u9

=== debian/changelog ===
freetype (2.4.9-1.1+deb7u9) wheezy-security; urgency=medium

  * Non-maintainer upload by the ELTS team.
  * CVE-2015-9381: FreeType before 2.6.1 has a heap-based buffer
    over-read in T1_Get_Private_Dict in type1/t1parse.c.
  * CVE-2015-9382: FreeType before 2.6.1 has a buffer over-read in
    skip_comment in psaux/psobjs.c because ps_parser_skip_PS_token is
    mishandled in an FT_New_Memory_Face operation.
  * CVE-2015-9383: FreeType before 2.6.2 has a heap-based buffer
    over-read in tt_cmap14_validate in sfnt/ttcmap.c.

 -- Sylvain Beucler <beuc@debian.org>  Wed, 04 Sep 2019 11:49:26 +0200

freetype (2.4.9-1.1+deb7u8) wheezy-security; urgency=medium

  * Non-maintainer upload by the ELTS team.
  * CVE-2015-9290: Fix potential buffer overflow. src/type1/t1parse.c
    (T1_Get_Private_Dict): Assure `cur' doesn't point to end of file
    buffer.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 31 Jul 2019 19:25:24 +0200

freetype (2.4.9-1.1+deb7u7) wheezy-security; urgency=medium

  * Non-maintainer upload by the LTS team.
  * CVE-2017-8287: Out of bounds write caused by heap buffer overflow in
    psh_glyph_init.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Sat, 06 May 2017 12:13:19 +0200

freetype (2.4.9-1.1+deb7u6) wheezy-security; urgency=medium

  * Non-maintainer upload by the LTS team.
  * CVE-2017-8105: Out of bounds write caused by heap buffer overflow in
    t1_builder_add_point.
  * CVE-2016-10328: Drop patch. Turns out the wheezy version wasn't
    affected by this issue, only the master branch was affected.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Wed, 26 Apr 2017 16:49:53 +0200

freetype (2.4.9-1.1+deb7u5) wheezy-security; urgency=high

  * Non-maintainer upload by the LTS team.
  * Fix the following security vulnerability:
    - CVE-2016-10328:
      out-of-bounds write caused by a heap-based buffer overflow related to the
      cff_parser_run function in cff/cffparse.c.

 -- Markus Koschany <apo@debian.org>  Mon, 17 Apr 2017 15:10:59 +0200

freetype (2.4.9-1.1+deb7u4) wheezy-security; urgency=high

  * CVE-2016-10244: The parse_charstrings function in type1/t1load.c did not
    ensure that a font contains a glyph name, which allowed remote attackers to
    cause a denial of service via a specially-crafted file. (Closes: #856971)

 -- Chris Lamb <lamby@debian.org>  Tue, 07 Mar 2017 11:50:15 +0000
